/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package util;

import java.io.IOException;
import java.net.HttpURLConnection;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.concurrent.WorkerStateEvent;
import javafx.event.EventHandler;
import org.json.JSONArray;
import org.json.JSONException;

import org.json.JSONObject;
import util.HttpClass;
import util.JsonResponse;

public class EmailService {

    String region = "ap-south-1";

    String email_url = "https://6z39zxat9k.execute-api.ap-south-1.amazonaws.com/v1/notification/publishsmsemail";

    public JsonResponse sendOtpMail(String email_to, String otp) {
        JSONObject emailBody = new JSONObject();
        JSONArray endpoints = new JSONArray();
        try {
            emailBody.put("region", region);
            System.out.println("Ötp sending => " + otp);
            endpoints.put(new JSONObject().put("endpoint", email_to).put("message", getOptMessage(otp))
                    .put("protocol", "email").put("subject", "Advait SCADA - Login OTP"));
            emailBody.put("endpoints", endpoints);
            OTPSend otpSendTask = new OTPSend(email_url, emailBody.toString());
            otpSendTask.setOnSucceeded(new EventHandler<WorkerStateEvent>() {
                @Override
                public void handle(WorkerStateEvent event) {
                    System.out.println(" Successfully sent emails to All endpoints:>" + emailBody.toString());
                }

            }
            );
            otpSendTask.restart();
            return (new JsonResponse("success", "An OTP has been sent to your registered email address !!"));

        } catch (Exception e) {

            e.printStackTrace();

            return (new JsonResponse("fail", "Failed to Send Email !"));

        }
    }

    public String getOptMessage(String otp) {
        String htmlEmailContent = "<!DOCTYPE html>"
                + "<html lang='en'>"
                + "<head>"
                + "    <meta charset='UTF-8'>"
                + "    <meta name='viewport' content='width=device-width, initial-scale=1.0'>"
                + "    <title>OTP Verification</title>"
                + "    <style>"
                + "        body {font-family: Arial, sans-serif; margin: 0; padding: 0; background-color: #f4f4f4;}"
                + "        .container {width: 100%; max-width: 600px; margin: 0 auto; padding: 20px; background-color: #ffffff; border-radius: 8px; box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);}"
                + "        h1 {font-size: 24px; color: #333333;}"
                + "        p {font-size: 16px; color: #555555;}"
                + "        .otp {font-size: 22px; font-weight: bold; color: #0000FF; margin: 20px 0;}"
                + "        .footer {margin-top: 20px; font-size: 14px; color: #888888; text-align: center;}"
                + "        .footer a {color: #ff4c4c; text-decoration: none;}"
                + "    </style>"
                + "</head>"
                + "<body>"
                + "    <div class='container'>"
                + "        <h1>OTP Verification</h1>"
                + "        <p>Dear User,</p>"
                + "        <p>Your One-Time Password (OTP) for verification is:</p>"
                + "        <div class='otp'>" + otp + "</div>"
                + "        <p>Please enter this OTP to proceed. If you did not request this, please ignore this email.</p>"
                + "        <p>Thank you!</p>"
                + "        <div class='footer'>"
                + "            <p>&copy; 2024 TASIND. All rights reserved.</p>"
                + "            <p>If you have any questions, please contact our <a href='mailto:support@tasind.com'>support team</a>.</p>"
                + "        </div>"
                + "    </div>"
                + "</body>"
                + "</html>";
        return htmlEmailContent;
    }

}
