/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package wp500firmwaretoolnew.controllers;

import util.OTPService;
import util.EmailService;
import java.io.IOException;
import java.net.URL;
import java.util.Random;
import java.util.ResourceBundle;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.image.Image;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.Pane;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.stage.StageStyle;
import util.JsonResponse;

/**
 * FXML Controller class
 *
 * @author TEST
 */
public class LoginPageController implements Initializable {

    @FXML
    private TextField emailTextField;
    @FXML
    private Button loginBtn;
    @FXML
    private Label msgLabel;
    @FXML
    private BorderPane loginPane;

    @Override
    public void initialize(URL url, ResourceBundle rb) {
        // TODO
        msgLabel.setWrapText(true);
    }

    @FXML
    private void sendOtpToEmail(ActionEvent event) {

        String email = emailTextField.getText().trim();
        String emailRegex = "^[a-zA-Z0-9._%+-]+@tasind\\.com$";//"^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\\.[a-zA-Z]{2,}$";

        if (email.matches(emailRegex)) {
            // Email is valid
            System.out.println("Valid email address: " + email);
            // Proceed with sending OTP using OTPService

            // Generate and send OTP
            int otp = OTPService.getInstance().generateOTP(email);
            JsonResponse sendOtpMail = new EmailService().sendOtpMail(email, String.valueOf(otp));
            System.out.println("Response of email sent ==>>  " + sendOtpMail);
            if (sendOtpMail.getStatus().equalsIgnoreCase("success")) {
                // Check if OTP was sent successfully
                showMessage("success", "OTP Sent on Your mail Successfully.");
                System.out.println("OTP sent successfully to: " + email);

                // Load OTP verification page
                try {
                    FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("/wp500firmwaretoolnew/fxmls/otpPage.fxml"));
                    Pane openProjectPane = fxmlLoader.load();
                    Scene scene = new Scene(openProjectPane);
                    Stage stage = new Stage();
                    Image icon = new Image(getClass().getResourceAsStream("/img/advait_logo.png"));
                    stage.getIcons().add(icon);
                    OtpPageController controller = fxmlLoader.<OtpPageController>getController();
                    controller.setEmail(email, loginPane);
                    stage.setScene(scene);
                    stage.setMaximized(false);
                    stage.initModality(Modality.APPLICATION_MODAL);
                    stage.setResizable(false);
                    stage.setAlwaysOnTop(true);
                    stage.show();

                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            } else {
                //System.out.println("Failed to send OTP: " + result);
                showMessage("fail", "Failed to send OTP. Please try again.");
                // msgLabel.setText("Failed to send OTP. Please try again.");
            }

        } else {
            // Email is invalid
            System.out.println("Invalid email address: " + email);
            // Show error message to user
            showMessage("fail", "Please enter a valid email address ending with '@tasind.com'");
            // msgLabel.setText("Please enter a valid email address ending with '@tasind.com'");
        }

    }

    private boolean isvalidEmail(String email) {
        String emailRegex = "^[a-zA-Z0-9_+&*-]+(?:\\.[a-zA-Z0-9_+&*-]+)*@(?:[a-zA-Z0-9-]+\\.)+[a-zA-Z]{2,7}$";
        return email.matches(emailRegex);
    }

    public void showMessage(String isSuccess, String message) {
        // Set the message text
        msgLabel.setText("");
        msgLabel.setText(message);

        // Set the message color based on the success flag
        if (isSuccess.equalsIgnoreCase("success")) {
            msgLabel.setTextFill(Color.GREEN);
        } else {
            msgLabel.setTextFill(Color.RED);
        }

        // Set the font size for better visibility (optional)
        msgLabel.setFont(new Font("vardhana", 14));

        // Create a Timeline to hide the message after 5 seconds
//        Timeline timeline = new Timeline(new KeyFrame(
//                Duration.seconds(5),
//                ae -> vaildMessageLabel.setText("")
//        ));
//        timeline.play();
    }
}
