/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package wp500firmwaretoolnew.controllers;

import java.io.IOException;
import util.OTPService;
import java.net.URL;
import java.util.ResourceBundle;
import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.ButtonType;
import javafx.scene.control.DialogPane;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.image.Image;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.Pane;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.stage.WindowEvent;
import javafx.util.Duration;

/**
 * FXML Controller class
 *
 * @author TEST
 */
public class OtpPageController implements Initializable {

    @FXML
    private Label emailMsgLabel;
    @FXML
    private TextField otpTextfield;
    @FXML
    private Button submitOtpBtn;
    private String userEmail;
    @FXML
    private BorderPane otpPane;
    private BorderPane LoginPane;
    @FXML
    private Label resendOTP;
    @FXML
    private Label otpMsgLabel;

    /**
     * Initializes the controller class.
     */
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        // TODO
        emailMsgLabel.setWrapText(true);
        otpMsgLabel.setWrapText(true);

    }

    @FXML
    private void validateOtp(ActionEvent event) {
        String otpInput = otpTextfield.getText().trim(); // Trim to remove any leading/trailing whitespace

        // Check if the OTP text field is empty
        if (otpInput.isEmpty()) {
            showMessage("fail", "Please enter OTP first.");
            return; // Exit the method if OTP is not entered
        }

        try {
            int otp = Integer.parseInt(otpInput); // Parse the OTP input to an integer
            boolean validate = OTPService.getInstance().validate(userEmail, otp);
            System.out.println("validate otp response ==>> " + validate);

            if (validate) {
                showMessage("success", "Valid OTP.");

                // Close the current stage (OTP Pane)
                Stage currentStage = (Stage) ((Node) event.getSource()).getScene().getWindow();
                currentStage.close();

                // Close the Login Pane stage if it's open
                if (LoginPane != null) {
                    Stage loginStage = (Stage) LoginPane.getScene().getWindow();
                    if (loginStage != null) {
                        loginStage.close();
                    }
                }

                // Load and display the main screen
                try {
                    FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("/wp500firmwaretoolnew/fxmls/mainScreen.fxml"));
                    Pane openProjectPane = fxmlLoader.load();
                    Scene scene = new Scene(openProjectPane);
                    Stage stage = new Stage();
                    Image icon = new Image(getClass().getResourceAsStream("/img/advait_logo.png"));
                    stage.getIcons().add(icon);
                    stage.setScene(scene);
                    stage.setMaximized(false);
                    stage.initModality(Modality.NONE);
                    stage.setResizable(true);
                    stage.show();
                    stage.setOnCloseRequest(event1 -> {
                        Alert alert = new Alert(Alert.AlertType.CONFIRMATION);

                        // Set the alert's title and header text
                        alert.setTitle("Exit");
                        alert.setHeaderText("Are you sure you want to close the application?");

                        // Customize the buttons to show only "Yes" and "No"
                        alert.getButtonTypes().setAll(ButtonType.YES, ButtonType.NO);

                        // Style the dialog (optional)
                        DialogPane dialog = alert.getDialogPane();
                        dialog.setStyle("-fx-font-size: 14px; -fx-font-weight: bold;");
                        Stage alertStage = (Stage) dialog.getScene().getWindow();
                        alertStage.getIcons().add(icon);

                        // Show the alert and wait for the response
                        alert.showAndWait().ifPresent(response -> {
                            if (response == ButtonType.YES) {
                                // If 'Yes' is clicked, allow the application to exit
                                System.exit(0);
                            } else {
                                // If 'No' is clicked, consume the event to prevent closing
                                event1.consume();
                            }
                        });
                    });
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            } else {
                showMessage("fail", "Invalid OTP, please enter a valid OTP.");
            }
        } catch (NumberFormatException e) {
            showMessage("fail", "OTP must be a valid number.");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    void setEmail(String email, BorderPane loginPane) {
        this.userEmail = email;
        System.out.println("email is : " + email + userEmail);
        emailMsgLabel.setText("Enter 6 digit code sent to your email : " + email);
        this.LoginPane = loginPane;
    }

    private void editEmailAction(ActionEvent event) {
        try {
            Stage currentStage = (Stage) ((Node) event.getSource()).getScene().getWindow();
            currentStage.close();
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("/wp500firmwaretoolnew/fxmls/loginPage.fxml"));
            Pane openProjectPane = fxmlLoader.load();
            Scene scene = new Scene(openProjectPane);
            Stage stage = new Stage();
            Image icon = new Image(getClass().getResourceAsStream("/img/advait_logo.png"));
            stage.getIcons().add(icon);
            stage.setScene(scene);
            stage.setMaximized(false);
            // stage.initModality(Modality.APPLICATION_MODAL);
            stage.setResizable(false);
            //stage.setAlwaysOnTop(true);
            stage.show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void showMessage(String isSuccess, String message) {
        // Set the message text
        otpMsgLabel.setText("");
        otpMsgLabel.setText(message);

        // Set the message color based on the success flag
        if (isSuccess.equalsIgnoreCase("success")) {
            otpMsgLabel.setTextFill(Color.GREEN);
        } else {
            otpMsgLabel.setTextFill(Color.RED);
        }

        // Set the font size for better visibility (optional)
        otpMsgLabel.setFont(new Font("vardhana", 11));

        // Create a Timeline to hide the message after 5 seconds
        Timeline timeline = new Timeline(new KeyFrame(
                Duration.seconds(5),
                ae -> otpMsgLabel.setText("")
        ));
        timeline.play();
    }

}
