/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package wp500firmwaretoolnew.controllers;

import java.io.BufferedReader;
import java.net.URL;
import java.util.ResourceBundle;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardCopyOption;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.animation.KeyFrame;
import javafx.application.Platform;
import javafx.scene.Scene;
import javafx.scene.control.Alert;
import javafx.scene.control.ButtonType;
import javafx.scene.control.DialogPane;
import javafx.scene.control.Tooltip;
import javafx.scene.image.Image;
import javafx.scene.paint.Color;
import javafx.scene.text.Font;
import javafx.stage.Stage;
import javafx.util.Duration;
import javafx.animation.Timeline;

/**
 *
 * @author TEST
 */
public class mainScreenController implements Initializable {

    private static final Logger LOGGER = Logger.getLogger(mainScreenController.class.getName());
    private Label label;
    @FXML
    private TextField textFieldOfMacId;
    @FXML
    private TextField textFieldOfSerialNo;
    @FXML
    private Button executeBtn;
    @FXML
    private Button updateBtn;
    @FXML
    private Button clearBtn;
    @FXML
    private Label errorMsg;
    @FXML
    private TextArea consoleTextAreaField;
    File file;
    @FXML
    private Button bootLoader;

    private void handleButtonAction(ActionEvent event) {
        System.out.println("You clicked me!");
        label.setText("Hello World!");
    }

    @Override
    public void initialize(URL url, ResourceBundle rb) {
        // TODO
        executeBtn.setDisable(true);
        bootLoader.setDisable(true);
        consoleTextAreaField.setEditable(false);
        setupTooltips();
    }

    private void setupTooltips() {
        // Using the common method to set tooltips and styles
        addTooltipAndStyle(clearBtn, "clear all field's");
        addTooltipAndStyle(updateBtn, "update .auto file");
        addTooltipAndStyle(executeBtn, "load image");
        addTooltipAndStyle(bootLoader, "load bootloader");

    }

    private void addTooltipAndStyle(Button button, String tooltipText) {
        // Create a tooltip
        Tooltip tooltip = new Tooltip(tooltipText);

        // Apply the custom CSS style
        tooltip.getStyleClass().add("custom-tooltip");

        // Set the tooltip to the button
        button.setTooltip(tooltip);

        // Load the CSS file into the scene
        Scene scene = button.getScene();
        if (scene != null) {
            scene.getStylesheets().add(getClass().getResource("/wp500firmwaretoolnew/css/tooltip.css").toExternalForm());
        } else {
            // Add a listener to add the stylesheet when the scene becomes available
            button.sceneProperty().addListener((obs, oldScene, newScene) -> {
                if (newScene != null) {
                    newScene.getStylesheets().add(getClass().getResource("/wp500firmwaretoolnew/css/tooltip.css").toExternalForm());
                }
            });
        }
    }

    @FXML
    private void executeBtnAction(ActionEvent event) {
        consoleTextAreaField.clear();
        executeFactoryTest();
    }

    private void executeFactoryTest() {
        // Create a confirmation alert
        Alert alert = new Alert(Alert.AlertType.WARNING);
        alert.setTitle("Factory Test Confirmation");
        alert.setHeaderText("Are you sure you want to execute the factory test?");
        alert.setContentText("Executing this test may cause changes to the system.");
        alert.getButtonTypes().setAll(ButtonType.OK, ButtonType.CANCEL);

        DialogPane dialog = alert.getDialogPane();
        dialog.setStyle("  -fx-font-size: 12px;\n" + "    -fx-font-weight: bold; ");
        Image icon = new Image(getClass().getResourceAsStream("/img/advait_logo.png"));
        Stage stage = (Stage) dialog.getScene().getWindow();
        stage.getIcons().add(icon);

        alert.showAndWait().ifPresent(response -> {
            if (response == ButtonType.OK) {
                // User confirmed; execute the factory test
                executeCommand();
            } else {
                alert.close();
                System.out.println("Operation cancelled.");
            }
        });

    }

    private void executeCommand() {

        new Thread(() -> {
            // Paths to the files that need to be checked
            String filePath1 = "uuu.exe";
            String filePath2 = "uuu_8E4D_tas_factory.auto";

            // Command to be executed
            String command = "uuu.exe uuu_8E4D_tas_factory.auto";

            try {
                // Check if both files exist
                File file1 = new File(filePath1);
                File file2 = new File(filePath2);
                if (file1.exists() && file2.exists()) {
                    // If both files exist, proceed with executing the command

                    // Command to open cmd and run a command inside it
                    String cmd = "cmd.exe /c start cmd.exe /k \"" + command + "\"";

                    // Execute the command to open cmd and run the specified command
                    Runtime.getRuntime().exec(cmd);

                    // Log success message to TextArea
                    Platform.runLater(() -> {
                        consoleTextAreaField.appendText(" Both files found." + "\n" + " Command executed: " + command + "\n");
                      
                    });
                } else {
                    // If either file does not exist, log an error message
                    StringBuilder errorMessage = new StringBuilder("Error: The following file(s) not found:\n");
                    if (!file1.exists()) {
                        errorMessage.append(filePath1).append("\n");
                    }
                    if (!file2.exists()) {
                        errorMessage.append(filePath2).append("\n");
                    }

                    Platform.runLater(() -> {
                        consoleTextAreaField.appendText(errorMessage.toString());
                        executeBtn.setDisable(false);
                    });
                }
            } catch (Exception e) {
                // Handle any errors
                Platform.runLater(() -> {
                    consoleTextAreaField.appendText("Error: " + e.getMessage() + "\n");
                });
                e.printStackTrace();
            }
        }).start();

    }

    @FXML
    private void updatebtnAction(ActionEvent event) {
        consoleTextAreaField.clear();
        String macId = textFieldOfMacId.getText().trim();
        String serialNo = textFieldOfSerialNo.getText().trim();
        String filePath = "uuu_8E4D_tas_factory.auto";//F:/wp500 tool/WP500FirmwareToolNew/
        String serialNoRegex = "^[a-zA-Z0-9]{30}$";

        try {
            // Validate MAC ID and Serial Number
            if (isValidMacId(macId) && isValidSerialNo(serialNo)) {
                // If both are valid, proceed with the update operations
                updateMacIdInFile(filePath, macId);
                updateSerialNoInFile(filePath, serialNo);
            }
            // No need for else block since validation methods already handle logging and error display
        } catch (Exception e) {
            LOGGER.severe("Exception in updatebtnAction: " + e.getMessage());
            showMessage("fail", "Exception in updatebtnAction: " + e.getMessage());
            e.printStackTrace();
        }

    }

    @FXML
    private void clearBtnAction(ActionEvent event) {
        textFieldOfMacId.clear();
        textFieldOfSerialNo.clear();
        consoleTextAreaField.clear();
        errorMsg.setText("");
        executeBtn.setDisable(true);
        bootLoader.setDisable(true);
    }

    private boolean isValidMacId(String macId) {
        // Check if the MAC ID is blank
        if (macId == null || macId.trim().isEmpty()) {
            LOGGER.severe("MAC ID is blank.");
            showMessage("fail", "Error: MAC ID cannot be blank.");
            return false;
        }

        // Regular expression for MAC ID in the format 'sd:dh:fh:hs:12:dy'
        String macIdRegex = "^[a-fA-F0-9]{2}(:[a-fA-F0-9]{2}){5}$";

        // Validate the MAC ID against the regex
        if (!macId.matches(macIdRegex)) {
            LOGGER.severe("Invalid MAC ID format.");
            showMessage("fail", "Error: MAC ID is not in the proper format 'sd:dh:fh:hs:12:dy'");
            return false;
        }

        return true;
    }

    private boolean isValidSerialNo(String serialNo) {
        // Check if the Serial Number is blank
        if (serialNo == null || serialNo.trim().isEmpty()) {
            LOGGER.severe("Serial Number is blank.");
            showMessage("fail", "Error: Serial Number cannot be blank.");
            return false;
        }

        // Regular expression for Serial Number: exactly 10 alphanumeric/numeric characters
        String serialNoRegex = "^[a-zA-Z0-9]{10}$";

        // Validate the Serial Number against the regex
        if (!serialNo.matches(serialNoRegex)) {
            LOGGER.severe("Invalid Serial Number format.");
            showMessage("fail", "Error: Serial Number must be exactly 10 alphanumeric/numeric characters.");
            return false;
        }

        return true;
    }

    private void updateMacIdInFile(String filePath, String macId) {
        file = new File(filePath);

        LOGGER.log(Level.INFO, "Starting MAC ID update process.");

        // Verify that the file exists
        if (!file.exists()) {
            LOGGER.log(Level.SEVERE, "File does not exist: {0}", filePath);
            showMessage("fail", "File does not exist: {0}" + filePath);
            return;
        }

        // Remove colons from MAC ID
        String macIdWithoutColons = macId.replace(":", "");

        // Check the MAC ID length
        if (macIdWithoutColons.length() != 12) {
            LOGGER.log(Level.SEVERE, "Invalid MAC ID length: {0}. It should be 12 hexadecimal characters long.", macIdWithoutColons.length());
            showMessage("fail", "Invalid MAC ID length: {0}. It should be 12 hexadecimal characters long.");
            return;
        }

        // Prepare the replacement values
        String[] macOctets = new String[6];
        for (int i = 0; i < 6; i++) {
            macOctets[i] = macIdWithoutColons.substring(i * 2, i * 2 + 2);
            LOGGER.log(Level.INFO, "MAC ID Octet {0}: {1}", new Object[]{i, macOctets[i]});
        }

        try {
            // Read the file content
            List<String> lines = Files.readAllLines(Paths.get(filePath));
            LOGGER.log(Level.INFO, "File read successfully.");
            showMessage("success", "File read successfully.");

            // Replace the specific lines with new MAC address values
            for (int i = 0; i < lines.size(); i++) {
                String line = lines.get(i);
                if (line.contains("ucmd mw.b 1000")) {
                    lines.set(i, line.replaceFirst("(?<=ucmd mw.b 1000 )\\w{2}", macOctets[0]));
                    LOGGER.log(Level.INFO, "Updated MAC ID at memory location 1000.");
                } else if (line.contains("ucmd mw.b 1001")) {
                    lines.set(i, line.replaceFirst("(?<=ucmd mw.b 1001 )\\w{2}", macOctets[1]));
                    LOGGER.log(Level.INFO, "Updated MAC ID at memory location 1001.");
                } else if (line.contains("ucmd mw.b 1002")) {
                    lines.set(i, line.replaceFirst("(?<=ucmd mw.b 1002 )\\w{2}", macOctets[2]));
                    LOGGER.log(Level.INFO, "Updated MAC ID at memory location 1002.");
                } else if (line.contains("ucmd mw.b 1003")) {
                    lines.set(i, line.replaceFirst("(?<=ucmd mw.b 1003 )\\w{2}", macOctets[3]));
                    LOGGER.log(Level.INFO, "Updated MAC ID at memory location 1003.");
                } else if (line.contains("ucmd mw.b 1004")) {
                    lines.set(i, line.replaceFirst("(?<=ucmd mw.b 1004 )\\w{2}", macOctets[4]));
                    LOGGER.log(Level.INFO, "Updated MAC ID at memory location 1004.");
                } else if (line.contains("ucmd mw.b 1005")) {
                    lines.set(i, line.replaceFirst("(?<=ucmd mw.b 1005 )\\w{2}", macOctets[5]));
                    LOGGER.log(Level.INFO, "Updated MAC ID at memory location 1005.");
                }
            }

            // Write the modified content back to the file
            Files.write(Paths.get(filePath), lines);
            LOGGER.log(Level.INFO, "MAC ID updated in file successfully.");
            showMessage("success", "MAC ID updated in file successfully.");

        } catch (IOException e) {
            LOGGER.log(Level.SEVERE, "Error updating the file: {0}", e.getMessage());
            showMessage("fail", "Error while update MAC ID In File");
        }
    }

    private void updateSerialNoInFile(String filePath, String serialNo) {
        LOGGER.log(Level.INFO, "Starting Serial Number update process.");

        File file = new File(filePath);

        // Verify that the file exists
        if (!file.exists()) {
            LOGGER.log(Level.SEVERE, "File does not exist: {0}", filePath);
            showMessage("fail", "File does not exist: {0}" + filePath);
            return;
        }

        // Verify that the serial number length is valid
        if (serialNo.length() < 6) {
            LOGGER.log(Level.SEVERE, "Serial number must be at least 8 characters long. Provided length: {0}", serialNo.length());
            showMessage("fail", "Serial number must be at least 8 characters long.");
            return;
        }

        // Convert serial number to ASCII hexadecimal
        StringBuilder hexBuilder = new StringBuilder();
        for (char c : serialNo.toCharArray()) {
            hexBuilder.append(String.format("%02X ", (int) c));
        }

        String hexSerialNo = hexBuilder.toString().trim();
        LOGGER.log(Level.INFO, "Converted Serial Number to hexadecimal: {0}", hexSerialNo);
        showMessage("success", "Converted Serial Number to hexadecimal.");

        String[] serialOctets = hexSerialNo.split(" ");
        int numberOfLinesForSerial = serialOctets.length;

        if (numberOfLinesForSerial > 30) {
            LOGGER.log(Level.SEVERE, "Error: the serial number is too long. Maximum supported length is 20 characters.");
            showMessage("fail", "Error: The serial number is too long. Maximum supported length is 20 characters.");
            return;
        }

        try {
            List<String> lines = Files.readAllLines(Paths.get(filePath));
            LOGGER.log(Level.INFO, "File read successfully.");
            showMessage("success", "File read successfully.");

            List<String> updatedLines = new ArrayList<>();
            boolean insideBlock = false;

            for (String line : lines) {
                if (line.contains("FB: ucmd sf read 0x1010 0x1f00400 0x05")) {
                    insideBlock = true;
                    updatedLines.add(line); // Keep the start line
                    updatedLines.add(""); // Add an empty line before the serial number block
                    // Insert serial number logic here
                    updatedLines.add("#Procedure to write serial number");
                    updatedLines.add("FB: ucmd md.b 1020");

                    int baseAddress = 1020;
                    for (int i = 0; i < numberOfLinesForSerial; i++) {
                        updatedLines.add(String.format("FB: ucmd mw.b %d %s 01", baseAddress + i, serialOctets[i]));
                    }

                    // Add fixed last two fields
                    updatedLines.add(String.format("FB: ucmd mw.b %d 5c 01", baseAddress + numberOfLinesForSerial));
                    updatedLines.add(String.format("FB: ucmd mw.b %d 30 01", baseAddress + numberOfLinesForSerial + 1));

                    updatedLines.add("FB: ucmd sf write 0x1020 0x1f00500 0x0a");
                    updatedLines.add(""); // Add an empty line after the serial number block
                    continue; // Skip further lines until the end of the block is found
                }

                if (insideBlock && line.contains("FB: ucmd setenv fastboot_dev mmc")) {
                    insideBlock = false;
                    updatedLines.add(line); // Keep the end line
                } else if (!insideBlock) {
                    updatedLines.add(line); // Add lines outside the block
                }
            }

            // Write the modified content back to the file
            Files.write(Paths.get(filePath), updatedLines);
            LOGGER.log(Level.INFO, "Serial number updated in file successfully.");
            showMessage("success", "Serial number & MAC ID updated in file successfully.");
            // executeBtn.setDisable(false);
            bootLoader.setDisable(false);

        } catch (IOException e) {
            LOGGER.log(Level.SEVERE, "Error updating the file: {0}", e.getMessage());
            showMessage("fail", "Error while updating serial number in file");
        }
    }

    @FXML
    private void executeBootloaderAction(ActionEvent event) {
        consoleTextAreaField.clear();
        downloadBootLoader();
    }

    private void downloadBootLoader() {
        // Create a confirmation alert
        Alert alert = new Alert(Alert.AlertType.WARNING);
        alert.setTitle("Bootloader Download Confirmation");
        alert.setHeaderText("Are you sure you want to download the bootloader?");
        alert.setContentText("This action will initiate the bootloader download process.");
        alert.getButtonTypes().setAll(ButtonType.OK, ButtonType.CANCEL);

        DialogPane dialog = alert.getDialogPane();
        dialog.setStyle("  -fx-font-size: 12px;\n" + "    -fx-font-weight: bold; ");
        Image icon = new Image(getClass().getResourceAsStream("/img/advait_logo.png"));
        Stage stage = (Stage) dialog.getScene().getWindow();
        stage.getIcons().add(icon);

        alert.showAndWait().ifPresent(response -> {
            if (response == ButtonType.OK) {
                // User confirmed; execute the bootloader download
                executeBootLoaderDownload();
            } else {
                alert.close();
                System.out.println("Operation cancelled.");
            }
        });

    }

    private void executeBootLoaderDownload() {
        new Thread(() -> {
            // Paths to the files that need to be checked
            String filePath1 = "uuu.exe";
            String filePath2 = "imx-boot-taswp500-fspi.bin-flash_evk_flexspi";

            // Command to be executed
            String command = "uuu.exe -b qspi imx-boot-taswp500-fspi.bin-flash_evk_flexspi";

            try {
                // Check if both files exist
                File file1 = new File(filePath1);
                File file2 = new File(filePath2);
                if (file1.exists() && file2.exists()) {
                    // If both files exist, proceed with executing the command

                    // Command to open cmd and run a command inside it
                    String cmd = "cmd.exe /c start cmd.exe /k \"" + command + "\"";

                    // Execute the command to open cmd and run the specified command
                    Runtime.getRuntime().exec(cmd);

                    // Log success message to TextArea
                    Platform.runLater(() -> {
                        consoleTextAreaField.appendText(" Both files found." + "\n" + " Command executed: " + command + "\n");
                        executeBtn.setDisable(false);
                    });
                } else {
                    // If either file does not exist, log an error message
                    StringBuilder errorMessage = new StringBuilder("Error: The following file(s) not found:\n");
                    if (!file1.exists()) {
                        errorMessage.append(filePath1).append("\n");
                       
                    }
                    if (!file2.exists()) {
                        errorMessage.append(filePath2).append("\n");
                       
                    }

                    Platform.runLater(() -> {
                        consoleTextAreaField.appendText(errorMessage.toString());
                        executeBtn.setDisable(true);
                    });
                }
            } catch (Exception e) {
                // Handle any errors
                Platform.runLater(() -> {
                    consoleTextAreaField.appendText("Error: " + e.getMessage() + "\n");
                });
                e.printStackTrace();
            }
        }).start();

    }

    public void showMessage(String isSuccess, String message) {
        // Set the message text
        errorMsg.setText("");
        errorMsg.setText(message);

        // Set the message color based on the success flag
        if (isSuccess.equalsIgnoreCase("success")) {
            errorMsg.setTextFill(Color.GREEN);
        } else {
            errorMsg.setTextFill(Color.RED);
        }

        // Set the font size for better visibility (optional)
        errorMsg.setFont(new Font("vardhana", 14));

        // Create a Timeline to hide the message after 5 seconds
        Timeline timeline = new Timeline(new KeyFrame(
                Duration.seconds(5),
                ae -> errorMsg.setText("")
        ));
        timeline.play();
    }

}
